﻿#!/perl/bin/perl

use Socket;
use DBI;
use FileHandle;
use Time::Local;

($arg) = @ARGV;


#1時間前の日付取得
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time - 3600);

$year += 1900;
$mon = sprintf("%02d", $mon + 1);
$mday = sprintf("%02d", $mday);
$sdate = "$year-$mon-$mday";
$startH = $hour;
if($hour eq 23){
	$endH = 24;
}else{
	$endH = $hour + 1;
}

####################################################################
#設定はここから。
####################################################################

#任意の時間を処理する場合、以下を設定
#$sdate = '2010-06-03';
#$startH = '00';
#$endH = '21';

# 番組勢いグラフデータファイル格納ディレクトリ
$IDir = '../OnesegWWW/httpd-doc/ikioi';

# グラフデータファイルの保存期間
$ExpireShot = 41;

# EPG DB
$DBNAME = 'c:\oneseg24\epg.db';

#caption.plの場所
$ExecC = 'c:\perl\bin\perl c:\OneSegWWW\httpd-doc\caption.pl |';

####################################################################
#設定たぶんここまで。
####################################################################
&expire_file($IDir, '*', $ExpireShot * 86400);

my $dsn = 'DBI:SQLite:dbname='.$DBNAME;
my $dbh = DBI->connect($dsn, undef, undef, {RaiseError => 1, AutoCommit => 0});
my $sql = <<END;
select dc_id, dc_name from da_channel order by dc_id
END
my $sth = $dbh->prepare($sql);
my $rv = $sth->execute();
my @channel = ();
while (my $ref = $sth->fetch()) {
	my($dc_id, $dc_name) = @$ref;
	push(@channel, $dc_id);
}
my $sql = <<END;
select
 strftime('%Y%m%d-%H%M%S', e.dv_start_time),
 strftime('%H%M%S', datetime(e.dv_start_time, e.dv_duration)),
 strftime('%H:%M:%S', e.dv_duration),
 c.dc_ch
 from
 da_event e inner join da_channel c 
 on
 e.dv_service_id = c.dc_service_id 
 where
 datetime(e.dv_start_time, e.dv_duration) > datetime(?,?) and datetime(e.dv_start_time, e.dv_duration) <= datetime(?,?) and c.dc_id = ?
 order by
 e.dv_start_time
END
;#

undef $sth;
my $sth = $dbh->prepare($sql);
@objImg = ();
foreach $dc_id (@channel) {
	$rv = $sth->execute($sdate,"$startH hours", $sdate,"$endH hours", $dc_id);
	while (my $ref = $sth->fetch()) {
		my($dc_date, $dc_end, $dc_length, $dc_ch) = @$ref;
		push(@objImg, "$dc_date,$dc_end,$dc_length,$dc_ch");
	}
}
undef $sth;
$dbh->disconnect();	


foreach $objRimg (@objImg){
	($dc_date, $dc_end, $dc_length,$dc_ch) = split(/\,/, $objRimg);
	$dc_date =~ /[0-9][0-9]([0-9][0-9])([0-9][0-9])([0-9][0-9])-([0-9][0-9])([0-9][0-9])([0-9][0-9])/;
	$sp_year = $1;
	$sp_mon = $2;
	$sp_day = $3;
	$sp_hour = $4;
	$sp_min = $5;
	$sp_sec = $6;
	$dc_end =~ /([0-9][0-9])([0-9][0-9])([0-9][0-9])/;
	$ep_hour = $1;
	$ep_min = $2;
	$ep_sec = $3;

	$dc_length =~ /([0-9][0-9]):([0-9][0-9]):([0-9][0-9])/;
	$length = $1 * 3600 + $2 * 60 + $3;

	$sp_station = $dc_ch;

	$output = $IDir . '/' . $sp_year . $sp_mon . $sp_day . "-" . $sp_hour . $sp_min . $sp_sec . "-xxxxxx-" . $sp_station . ".txt";


#処理の説明:該当する番組の時間帯の字幕データ(.sub)ファイルをcaption.plを利用してgetしてくる。

	$sep= $length / 20;
#   $g_query  = "caption.pl?file=";
	$g_query  = "file=";
	$g_query .= $sp_year . $sp_mon . $sp_day . "-" . $sp_hour . $sp_min . $sp_sec . "-" . $ep_hour . $ep_min . $ep_sec . "-" . $sp_station . ".xml";
	print "[ch]:" . $sp_station ." [S]:". $sp_year ."/". $sp_mon ."/". $sp_day ."-".  $sp_hour ."-". $sp_min ."  [E]:". xxxxxx ."-". $ep_hour ."-". $ep_min. " [Length(sec)]:".$length." [Sepalate]:".$sep."sec x20\n";


#字幕データがあったらレス数とｷﾀｰ数をカウントして、再生時間の20等分(30分番組なら5分ごとの小計)を
#配列に落とし込んでいく。
	$ENV{'QUERY_STRING'} = $g_query;
	$ENV{'REQUEST_METHOD'} = "GET";

	open(IN, $ExecC);
	@total_sep  = ("0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0");
	@kita_sep   = ("0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0");

	$total=0;$kita=0;
	while (chomp($buf2=<IN>)) {
		$count="0";
		if($buf2 =~ /\<p begin/){
    			$res_h= substr($buf2,16,2);
			$res_m= substr($buf2,19,2);
			$res_s= substr($buf2,22,2);
			$res_now= $res_h*60*60;
			$res_now= $res_now + $res_m*60;
			$res_now= $res_now + $res_s;
			$send_sep = sprintf( "%d",$res_now / $sep);
 #print "\n\n $length @"."$send_sep $res_now".">\n";
			$count = $buf2;
			$count = $count =~ s/\<br\/\>//g;
			if($send_sep != 20){
				if($count eq ""){
					$total++; $total_sep[$send_sep]++;
    					if($buf2 =~ /キタ/||$buf2 =~ /ktkr/||$buf2 =~ /ｷﾀ/||$buf2 =~ /ww/||$buf2 =~ /ｗｗ/){
						$kita++;print "k";$kita_sep[$send_sep]++;}else{print "x";
					}
				}else{
					print "[".$count ."](";
					@word = split (/\<br\/\>/, $buf2);
					foreach $n (@word) {
						#ｷﾀｰ系のカウント。大体こんなキーワードがあればカウントしてます。	
						if($n =~ /キタ/||$n =~ /ktkr/||$n =~ /ｷﾀ/||$n =~ /ww/||$n =~ /ｗｗ/){
							$kita++;print "k";$kita_sep[$send_sep]++;}else{print "x";
						}
						$total++;$total_sep[$send_sep]++;
					}
					print ")";
				}
			}
		}
	}

	print "\n\n";

	print "[Result]\n total:".$total."res    ";  
	foreach $n (@total_sep) {print ",".$n;}print "\n";
	print " kita:".$kita ." ";  
	foreach $n (@kita_sep) {print ",".$n;}print "\n";
	print "\n $output \n\n\n";
	# 終了処理
	close(IN);
}

sub expire_file {
	($objdir, $objext,  $Expire) = @_;
	opendir(DIB,"$objdir");
	while($DirObj = readdir(DIB)){
		if(($objext eq '*') || ($DirObj =~ /$objext$/)){
			@retval = stat("$objdir\\$DirObj");
			if($retval[9] < (time - $Expire)){
				unlink("$objdir\\$DirObj");
			}
		}
	}
	closedir(DIB);
}

####汚いソースご覧頂きありがとうございました。
####DOSプロンプト上の出力の説明ですが
####xがコメント数。kがｷﾀｰ系と判別されたコメント数。
####.subファイルには同じ秒数帯に複数コメントが< /br>で記載されていることがあるので
####[]は一行に何個レスがあったか。()内はそれぞれのレス解析結果です。